Index: /trunk/sources/HeuristicLab.SimOpt/DoubleParameterBoundConstraintView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.SimOpt/DoubleParameterBoundConstraintView.Designer.cs	(revision 1411)
+++ /trunk/sources/HeuristicLab.SimOpt/DoubleParameterBoundConstraintView.Designer.cs	(revision 1412)
@@ -60,5 +60,5 @@
       this.ubTextBox.Name = "ubTextBox";
       this.ubTextBox.Size = new System.Drawing.Size(83, 20);
-      this.ubTextBox.TabIndex = 31;
+      this.ubTextBox.TabIndex = 5;
       this.ubTextBox.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
       this.ubTextBox.Validated += new System.EventHandler(this.ubTextBox_Validated);
@@ -70,5 +70,5 @@
       this.lbTextBox.Name = "lbTextBox";
       this.lbTextBox.Size = new System.Drawing.Size(83, 20);
-      this.lbTextBox.TabIndex = 30;
+      this.lbTextBox.TabIndex = 2;
       this.lbTextBox.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
       this.lbTextBox.Validated += new System.EventHandler(this.lbTextBox_Validated);
@@ -81,5 +81,5 @@
       this.ubIncludedCheckBox.Name = "ubIncludedCheckBox";
       this.ubIncludedCheckBox.Size = new System.Drawing.Size(73, 17);
-      this.ubIncludedCheckBox.TabIndex = 29;
+      this.ubIncludedCheckBox.TabIndex = 6;
       this.ubIncludedCheckBox.Text = "Included?";
       this.ubIncludedCheckBox.UseVisualStyleBackColor = true;
@@ -92,5 +92,5 @@
       this.lbIncludedCheckBox.Name = "lbIncludedCheckBox";
       this.lbIncludedCheckBox.Size = new System.Drawing.Size(73, 17);
-      this.lbIncludedCheckBox.TabIndex = 28;
+      this.lbIncludedCheckBox.TabIndex = 3;
       this.lbIncludedCheckBox.Text = "Included?";
       this.lbIncludedCheckBox.UseVisualStyleBackColor = true;
@@ -104,5 +104,5 @@
       this.ubEnabledCheckBox.Name = "ubEnabledCheckBox";
       this.ubEnabledCheckBox.Size = new System.Drawing.Size(91, 17);
-      this.ubEnabledCheckBox.TabIndex = 27;
+      this.ubEnabledCheckBox.TabIndex = 4;
       this.ubEnabledCheckBox.Text = "Upper bound:";
       this.ubEnabledCheckBox.UseVisualStyleBackColor = true;
@@ -116,5 +116,5 @@
       this.lbEnabledCheckBox.Name = "lbEnabledCheckBox";
       this.lbEnabledCheckBox.Size = new System.Drawing.Size(91, 17);
-      this.lbEnabledCheckBox.TabIndex = 26;
+      this.lbEnabledCheckBox.TabIndex = 1;
       this.lbEnabledCheckBox.Text = "Lower bound:";
       this.lbEnabledCheckBox.UseVisualStyleBackColor = true;
@@ -126,5 +126,5 @@
       this.pmTextBox.Name = "pmTextBox";
       this.pmTextBox.Size = new System.Drawing.Size(156, 20);
-      this.pmTextBox.TabIndex = 32;
+      this.pmTextBox.TabIndex = 0;
       this.pmTextBox.TextChanged += new System.EventHandler(this.pmTextBox_TextChanged);
       // 
@@ -135,5 +135,5 @@
       this.pmLabel.Name = "pmLabel";
       this.pmLabel.Size = new System.Drawing.Size(38, 13);
-      this.pmLabel.TabIndex = 33;
+      this.pmLabel.TabIndex = 7;
       this.pmLabel.Text = "Name:";
       // 
Index: /trunk/sources/HeuristicLab.SimOpt/HeuristicLab.SimOpt.csproj
===================================================================
--- /trunk/sources/HeuristicLab.SimOpt/HeuristicLab.SimOpt.csproj	(revision 1411)
+++ /trunk/sources/HeuristicLab.SimOpt/HeuristicLab.SimOpt.csproj	(revision 1412)
@@ -66,4 +66,11 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="IntParameterBoundConstraintView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="IntParameterBoundConstraintView.Designer.cs">
+      <DependentUpon>IntParameterBoundConstraintView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="IntParameterBoundConstraint.cs" />
     <Compile Include="SimOptCrossoverPreparator.cs" />
     <Compile Include="SimOptSequentialSubOperatorProcessor.cs" />
@@ -96,4 +103,8 @@
   </ItemGroup>
   <ItemGroup>
+    <EmbeddedResource Include="IntParameterBoundConstraintView.resx">
+      <DependentUpon>IntParameterBoundConstraintView.cs</DependentUpon>
+      <SubType>Designer</SubType>
+    </EmbeddedResource>
     <EmbeddedResource Include="DoubleParameterBoundConstraintView.resx">
       <DependentUpon>DoubleParameterBoundConstraintView.cs</DependentUpon>
@@ -130,4 +141,8 @@
       <Name>HeuristicLab.PluginInfrastructure</Name>
     </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Random\HeuristicLab.Random.csproj">
+      <Project>{47019A74-F7F7-482E-83AA-D3F4F777E879}</Project>
+      <Name>HeuristicLab.Random</Name>
+    </ProjectReference>
     <ProjectReference Include="..\HeuristicLab.Selection\HeuristicLab.Selection.csproj">
       <Project>{F7CF0571-25CB-43D5-8443-0843A1E2861A}</Project>
Index: /trunk/sources/HeuristicLab.SimOpt/IntParameterBoundConstraint.cs
===================================================================
--- /trunk/sources/HeuristicLab.SimOpt/IntParameterBoundConstraint.cs	(revision 1412)
+++ /trunk/sources/HeuristicLab.SimOpt/IntParameterBoundConstraint.cs	(revision 1412)
@@ -0,0 +1,202 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2009 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Globalization;
+using System.Text;
+using System.Xml;
+using HeuristicLab.Constraints;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.SimOpt {
+  public class IntParameterBoundConstraint : ConstraintBase {
+    private int lowerBound;
+    public int LowerBound {
+      get { return lowerBound; }
+      set {
+        lowerBound = value;
+        OnChanged();
+      }
+    }
+    private bool lowerBoundIncluded;
+    public bool LowerBoundIncluded {
+      get { return lowerBoundIncluded; }
+      set {
+        lowerBoundIncluded = value;
+        OnChanged();
+      }
+    }
+    private bool lowerBoundEnabled;
+    public bool LowerBoundEnabled {
+      get { return lowerBoundEnabled; }
+      set {
+        lowerBoundEnabled = value;
+        OnChanged();
+      }
+    }
+    private int upperBound;
+    public int UpperBound {
+      get { return upperBound; }
+      set {
+        upperBound = value;
+        OnChanged();
+      }
+    }
+    private bool upperBoundIncluded;
+    public bool UpperBoundIncluded {
+      get { return upperBoundIncluded; }
+      set {
+        upperBoundIncluded = value;
+        OnChanged();
+      }
+    }
+    private bool upperBoundEnabled;
+    public bool UpperBoundEnabled {
+      get { return upperBoundEnabled; }
+      set {
+        upperBoundEnabled = value;
+        OnChanged();
+      }
+    }
+    private string parameterName;
+    public string ParameterName {
+      get { return parameterName; }
+      set {
+        parameterName = value;
+        OnChanged();
+      }
+    }
+
+    public override string Description {
+      get { return "The double is limited one or two sided by a lower and/or upper boundary"; }
+    }
+
+    public IntParameterBoundConstraint()
+      : this(int.MinValue, int.MaxValue, "undefined") {
+    }
+
+    public IntParameterBoundConstraint(int lowerBound, int upperBound, string parameterName)
+      : this(lowerBound, true, upperBound, true, parameterName) {
+    }
+
+    public IntParameterBoundConstraint(int lowerBound, bool lowerBoundIncluded, int upperBound, bool upperBoundIncluded, string parameterName)
+      : base() {
+      this.lowerBound = lowerBound;
+      this.lowerBoundIncluded = lowerBoundIncluded;
+      this.lowerBoundEnabled = true;
+      this.upperBound = upperBound;
+      this.upperBoundIncluded = upperBoundIncluded;
+      this.upperBoundEnabled = true;
+      this.parameterName = parameterName;
+    }
+
+
+    public override bool Check(IItem data) {
+      ConstrainedItemList list = (data as ConstrainedItemList);
+      if (list == null) return false;
+      for (int i = 0; i < list.Count; i++) {
+        if (list[i] is IVariable && ((IVariable)list[i]).Name.Equals(parameterName) && ((IVariable)list[i]).Value is IntData) {
+          if (LowerBoundEnabled && ((LowerBoundIncluded && ((IComparable)((IVariable)list[i]).Value).CompareTo(LowerBound) < 0)
+            || (!LowerBoundIncluded && ((IComparable)((IVariable)list[i]).Value).CompareTo(LowerBound) <= 0))) return false;
+          if (UpperBoundEnabled && ((UpperBoundIncluded && ((IComparable)((IVariable)list[i]).Value).CompareTo(UpperBound) > 0)
+            || (!UpperBoundIncluded && ((IComparable)((IVariable)list[i]).Value).CompareTo(UpperBound) >= 0))) return false;
+        }
+      }
+      return true;
+    }
+
+    public override IView CreateView() {
+      return new IntParameterBoundConstraintView(this);
+    }
+
+    public override object Clone(IDictionary<Guid, object> clonedObjects) {
+      IntParameterBoundConstraint clone = new IntParameterBoundConstraint();
+      clonedObjects.Add(Guid, clone);
+      clone.parameterName = (string)parameterName.Clone();
+      clone.upperBound = UpperBound;
+      clone.upperBoundIncluded = UpperBoundIncluded;
+      clone.upperBoundEnabled = UpperBoundEnabled;
+      clone.lowerBound = LowerBound;
+      clone.lowerBoundIncluded = LowerBoundIncluded;
+      clone.lowerBoundEnabled = LowerBoundEnabled;
+      return clone;
+    }
+
+    #region persistence
+    public override XmlNode GetXmlNode(string name, XmlDocument document, IDictionary<Guid, IStorable> persistedObjects) {
+      XmlNode node = base.GetXmlNode(name, document, persistedObjects);
+      XmlAttribute pm = document.CreateAttribute("ParameterName");
+      pm.Value = parameterName;
+      XmlAttribute lb = document.CreateAttribute("LowerBound");
+      lb.Value = LowerBound.ToString();
+      XmlAttribute lbi = document.CreateAttribute("LowerBoundIncluded");
+      lbi.Value = lowerBoundIncluded.ToString();
+      XmlAttribute lbe = document.CreateAttribute("LowerBoundEnabled");
+      lbe.Value = lowerBoundEnabled.ToString();
+      XmlAttribute ub = document.CreateAttribute("UpperBound");
+      ub.Value = upperBound.ToString();
+      XmlAttribute ubi = document.CreateAttribute("UpperBoundIncluded");
+      ubi.Value = upperBoundIncluded.ToString();
+      XmlAttribute ube = document.CreateAttribute("UpperBoundEnabled");
+      ube.Value = upperBoundEnabled.ToString();
+      node.Attributes.Append(pm);
+      node.Attributes.Append(lb);
+      if (!lowerBoundIncluded) node.Attributes.Append(lbi);
+      if (!lowerBoundEnabled) node.Attributes.Append(lbe);
+      node.Attributes.Append(ub);
+      if (!upperBoundIncluded) node.Attributes.Append(ubi);
+      if (!upperBoundEnabled) node.Attributes.Append(ube);
+      return node;
+    }
+
+    public override void Populate(XmlNode node, IDictionary<Guid, IStorable> restoredObjects) {
+      base.Populate(node, restoredObjects);
+      parameterName = node.Attributes["ParameterName"].Value;
+      lowerBound = int.Parse(node.Attributes["LowerBound"].Value, CultureInfo.InvariantCulture);
+      if (node.Attributes["LowerBoundIncluded"] != null) {
+        lowerBoundIncluded = bool.Parse(node.Attributes["LowerBoundIncluded"].Value);
+      } else {
+        lowerBoundIncluded = true;
+      }
+      if (node.Attributes["LowerBoundEnabled"] != null) {
+        lowerBoundEnabled = bool.Parse(node.Attributes["LowerBoundEnabled"].Value);
+      } else {
+        lowerBoundEnabled = true;
+      }
+
+      upperBound = int.Parse(node.Attributes["UpperBound"].Value, CultureInfo.InvariantCulture);
+      if (node.Attributes["UpperBoundIncluded"] != null) {
+        upperBoundIncluded = bool.Parse(node.Attributes["UpperBoundIncluded"].Value);
+      } else {
+        upperBoundIncluded = true;
+      }
+      if (node.Attributes["UpperBoundEnabled"] != null) {
+        upperBoundEnabled = bool.Parse(node.Attributes["UpperBoundEnabled"].Value);
+      } else {
+        upperBoundEnabled = true;
+      }
+    }
+    #endregion
+  }
+}
Index: /trunk/sources/HeuristicLab.SimOpt/IntParameterBoundConstraintView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.SimOpt/IntParameterBoundConstraintView.Designer.cs	(revision 1412)
+++ /trunk/sources/HeuristicLab.SimOpt/IntParameterBoundConstraintView.Designer.cs	(revision 1412)
@@ -0,0 +1,170 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.SimOpt {
+  partial class IntParameterBoundConstraintView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.ubTextBox = new System.Windows.Forms.TextBox();
+      this.lbTextBox = new System.Windows.Forms.TextBox();
+      this.ubIncludedCheckBox = new System.Windows.Forms.CheckBox();
+      this.lbIncludedCheckBox = new System.Windows.Forms.CheckBox();
+      this.ubEnabledCheckBox = new System.Windows.Forms.CheckBox();
+      this.lbEnabledCheckBox = new System.Windows.Forms.CheckBox();
+      this.pmTextBox = new System.Windows.Forms.TextBox();
+      this.pmLabel = new System.Windows.Forms.Label();
+      this.SuspendLayout();
+      // 
+      // ubTextBox
+      // 
+      this.ubTextBox.Location = new System.Drawing.Point(47, 107);
+      this.ubTextBox.Name = "ubTextBox";
+      this.ubTextBox.Size = new System.Drawing.Size(83, 20);
+      this.ubTextBox.TabIndex = 5;
+      this.ubTextBox.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
+      this.ubTextBox.Validated += new System.EventHandler(this.ubTextBox_Validated);
+      this.ubTextBox.Validating += new System.ComponentModel.CancelEventHandler(this.ubTextBox_Validating);
+      // 
+      // lbTextBox
+      // 
+      this.lbTextBox.Location = new System.Drawing.Point(47, 58);
+      this.lbTextBox.Name = "lbTextBox";
+      this.lbTextBox.Size = new System.Drawing.Size(83, 20);
+      this.lbTextBox.TabIndex = 2;
+      this.lbTextBox.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
+      this.lbTextBox.Validated += new System.EventHandler(this.lbTextBox_Validated);
+      this.lbTextBox.Validating += new System.ComponentModel.CancelEventHandler(this.lbTextBox_Validating);
+      // 
+      // ubIncludedCheckBox
+      // 
+      this.ubIncludedCheckBox.AutoSize = true;
+      this.ubIncludedCheckBox.Location = new System.Drawing.Point(136, 109);
+      this.ubIncludedCheckBox.Name = "ubIncludedCheckBox";
+      this.ubIncludedCheckBox.Size = new System.Drawing.Size(73, 17);
+      this.ubIncludedCheckBox.TabIndex = 6;
+      this.ubIncludedCheckBox.Text = "Included?";
+      this.ubIncludedCheckBox.UseVisualStyleBackColor = true;
+      this.ubIncludedCheckBox.CheckedChanged += new System.EventHandler(this.ubIncludedCheckBox_CheckedChanged);
+      // 
+      // lbIncludedCheckBox
+      // 
+      this.lbIncludedCheckBox.AutoSize = true;
+      this.lbIncludedCheckBox.Location = new System.Drawing.Point(136, 61);
+      this.lbIncludedCheckBox.Name = "lbIncludedCheckBox";
+      this.lbIncludedCheckBox.Size = new System.Drawing.Size(73, 17);
+      this.lbIncludedCheckBox.TabIndex = 3;
+      this.lbIncludedCheckBox.Text = "Included?";
+      this.lbIncludedCheckBox.UseVisualStyleBackColor = true;
+      this.lbIncludedCheckBox.CheckedChanged += new System.EventHandler(this.lbIncludedCheckBox_CheckedChanged);
+      // 
+      // ubEnabledCheckBox
+      // 
+      this.ubEnabledCheckBox.AutoSize = true;
+      this.ubEnabledCheckBox.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
+      this.ubEnabledCheckBox.Location = new System.Drawing.Point(3, 84);
+      this.ubEnabledCheckBox.Name = "ubEnabledCheckBox";
+      this.ubEnabledCheckBox.Size = new System.Drawing.Size(91, 17);
+      this.ubEnabledCheckBox.TabIndex = 4;
+      this.ubEnabledCheckBox.Text = "Upper bound:";
+      this.ubEnabledCheckBox.UseVisualStyleBackColor = true;
+      this.ubEnabledCheckBox.CheckedChanged += new System.EventHandler(this.ubEnabledCheckBox_CheckedChanged);
+      // 
+      // lbEnabledCheckBox
+      // 
+      this.lbEnabledCheckBox.AutoSize = true;
+      this.lbEnabledCheckBox.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
+      this.lbEnabledCheckBox.Location = new System.Drawing.Point(3, 35);
+      this.lbEnabledCheckBox.Name = "lbEnabledCheckBox";
+      this.lbEnabledCheckBox.Size = new System.Drawing.Size(91, 17);
+      this.lbEnabledCheckBox.TabIndex = 1;
+      this.lbEnabledCheckBox.Text = "Lower bound:";
+      this.lbEnabledCheckBox.UseVisualStyleBackColor = true;
+      this.lbEnabledCheckBox.CheckedChanged += new System.EventHandler(this.lbEnabledCheckBox_CheckedChanged);
+      // 
+      // pmTextBox
+      // 
+      this.pmTextBox.Location = new System.Drawing.Point(47, 7);
+      this.pmTextBox.Name = "pmTextBox";
+      this.pmTextBox.Size = new System.Drawing.Size(156, 20);
+      this.pmTextBox.TabIndex = 0;
+      this.pmTextBox.TextChanged += new System.EventHandler(this.pmTextBox_TextChanged);
+      // 
+      // pmLabel
+      // 
+      this.pmLabel.AutoSize = true;
+      this.pmLabel.Location = new System.Drawing.Point(3, 10);
+      this.pmLabel.Name = "pmLabel";
+      this.pmLabel.Size = new System.Drawing.Size(38, 13);
+      this.pmLabel.TabIndex = 7;
+      this.pmLabel.Text = "Name:";
+      // 
+      // IntParameterBoundConstraintView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.pmLabel);
+      this.Controls.Add(this.pmTextBox);
+      this.Controls.Add(this.ubTextBox);
+      this.Controls.Add(this.lbTextBox);
+      this.Controls.Add(this.ubIncludedCheckBox);
+      this.Controls.Add(this.lbIncludedCheckBox);
+      this.Controls.Add(this.ubEnabledCheckBox);
+      this.Controls.Add(this.lbEnabledCheckBox);
+      this.Name = "IntParameterBoundConstraintView";
+      this.Size = new System.Drawing.Size(206, 131);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.TextBox ubTextBox;
+    private System.Windows.Forms.TextBox lbTextBox;
+    private System.Windows.Forms.CheckBox ubIncludedCheckBox;
+    private System.Windows.Forms.CheckBox lbIncludedCheckBox;
+    private System.Windows.Forms.CheckBox ubEnabledCheckBox;
+    private System.Windows.Forms.CheckBox lbEnabledCheckBox;
+    private System.Windows.Forms.TextBox pmTextBox;
+    private System.Windows.Forms.Label pmLabel;
+  }
+}
Index: /trunk/sources/HeuristicLab.SimOpt/IntParameterBoundConstraintView.cs
===================================================================
--- /trunk/sources/HeuristicLab.SimOpt/IntParameterBoundConstraintView.cs	(revision 1412)
+++ /trunk/sources/HeuristicLab.SimOpt/IntParameterBoundConstraintView.cs	(revision 1412)
@@ -0,0 +1,140 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.SimOpt {
+  public partial class IntParameterBoundConstraintView : ViewBase {
+    public IntParameterBoundConstraint IntParameterBoundConstraint {
+      get { return (IntParameterBoundConstraint)Item; }
+      set { base.Item = value; }
+    }
+
+    public IntParameterBoundConstraintView() {
+      InitializeComponent();
+    }
+
+    public IntParameterBoundConstraintView(IntParameterBoundConstraint dpbc)
+      : this() {
+      IntParameterBoundConstraint = dpbc;
+    }
+
+    protected override void RemoveItemEvents() {
+      IntParameterBoundConstraint.Changed -= new EventHandler(IntParameterBoundConstraint_Changed);
+      base.RemoveItemEvents();
+    }
+
+    protected override void AddItemEvents() {
+      base.AddItemEvents();
+      IntParameterBoundConstraint.Changed += new EventHandler(IntParameterBoundConstraint_Changed);
+    }
+
+    protected override void UpdateControls() {
+      base.UpdateControls();
+      if (IntParameterBoundConstraint == null) {
+        pmTextBox.Enabled = false;
+        lbTextBox.Enabled = false;
+        lbTextBox.Text = "";
+        lbIncludedCheckBox.Enabled = false;
+        lbEnabledCheckBox.Checked = false;
+
+        ubTextBox.Enabled = false;
+        ubTextBox.Text = "";
+        ubIncludedCheckBox.Checked = false;
+        ubEnabledCheckBox.Enabled = false;
+      } else {
+        pmTextBox.Text = IntParameterBoundConstraint.ParameterName;
+        lbTextBox.Text = IntParameterBoundConstraint.LowerBound.ToString();
+        lbTextBox.Enabled = IntParameterBoundConstraint.LowerBoundEnabled;
+        lbIncludedCheckBox.Checked = IntParameterBoundConstraint.LowerBoundIncluded;
+        lbIncludedCheckBox.Enabled = true;
+        lbEnabledCheckBox.Checked = IntParameterBoundConstraint.LowerBoundEnabled;
+        lbEnabledCheckBox.Enabled = true;
+
+        ubTextBox.Text = IntParameterBoundConstraint.UpperBound.ToString();
+        ubTextBox.Enabled = IntParameterBoundConstraint.UpperBoundEnabled;
+        ubIncludedCheckBox.Checked = IntParameterBoundConstraint.UpperBoundIncluded;
+        ubIncludedCheckBox.Enabled = true;
+        ubEnabledCheckBox.Checked = IntParameterBoundConstraint.UpperBoundEnabled;
+        ubEnabledCheckBox.Enabled = true;
+      }
+    }
+
+    void IntParameterBoundConstraint_Changed(object sender, EventArgs e) {
+      Refresh();
+    }
+
+    private void lbEnabledCheckBox_CheckedChanged(object sender, EventArgs e) {
+      IntParameterBoundConstraint.LowerBoundEnabled = lbEnabledCheckBox.Checked;
+      lbTextBox.Enabled = lbEnabledCheckBox.Checked;
+      lbIncludedCheckBox.Enabled = lbEnabledCheckBox.Checked;
+    }
+
+    private void ubEnabledCheckBox_CheckedChanged(object sender, EventArgs e) {
+      IntParameterBoundConstraint.UpperBoundEnabled = ubEnabledCheckBox.Checked;
+      ubTextBox.Enabled = ubEnabledCheckBox.Checked;
+      ubIncludedCheckBox.Enabled = ubEnabledCheckBox.Checked;
+    }
+
+    private void lbIncludedCheckBox_CheckedChanged(object sender, EventArgs e) {
+      IntParameterBoundConstraint.LowerBoundIncluded = lbIncludedCheckBox.Checked;
+    }
+
+    private void ubIncludedCheckBox_CheckedChanged(object sender, EventArgs e) {
+      IntParameterBoundConstraint.UpperBoundIncluded = ubIncludedCheckBox.Checked;
+    }
+
+    private void lbTextBox_Validating(object sender, CancelEventArgs e) {
+      double result;
+      if (!double.TryParse(lbTextBox.Text, out result)) {
+        e.Cancel = true;
+      } 
+    }
+
+    private void ubTextBox_Validating(object sender, CancelEventArgs e) {
+      double result;
+      if (!double.TryParse(ubTextBox.Text, out result)) {
+        e.Cancel = true;
+      } 
+    }
+
+    private void lbTextBox_Validated(object sender, EventArgs e) {
+      IntParameterBoundConstraint.LowerBound = int.Parse(lbTextBox.Text);
+    }
+
+    private void ubTextBox_Validated(object sender, EventArgs e) {
+      IntParameterBoundConstraint.UpperBound = int.Parse(ubTextBox.Text);
+    }
+
+    private void pmTextBox_TextChanged(object sender, EventArgs e) {
+      IntParameterBoundConstraint.ParameterName = pmTextBox.Text;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.SimOpt/IntParameterBoundConstraintView.resx
===================================================================
--- /trunk/sources/HeuristicLab.SimOpt/IntParameterBoundConstraintView.resx	(revision 1412)
+++ /trunk/sources/HeuristicLab.SimOpt/IntParameterBoundConstraintView.resx	(revision 1412)
@@ -0,0 +1,120 @@
+<?xml version="1.0" encoding="utf-8"?>
+<root>
+  <!-- 
+    Microsoft ResX Schema 
+    
+    Version 2.0
+    
+    The primary goals of this format is to allow a simple XML format 
+    that is mostly human readable. The generation and parsing of the 
+    various data types are done through the TypeConverter classes 
+    associated with the data types.
+    
+    Example:
+    
+    ... ado.net/XML headers & schema ...
+    <resheader name="resmimetype">text/microsoft-resx</resheader>
+    <resheader name="version">2.0</resheader>
+    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
+    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
+    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
+    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
+    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
+        <value>[base64 mime encoded serialized .NET Framework object]</value>
+    </data>
+    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
+        <comment>This is a comment</comment>
+    </data>
+                
+    There are any number of "resheader" rows that contain simple 
+    name/value pairs.
+    
+    Each data row contains a name, and value. The row also contains a 
+    type or mimetype. Type corresponds to a .NET class that support 
+    text/value conversion through the TypeConverter architecture. 
+    Classes that don't support this are serialized and stored with the 
+    mimetype set.
+    
+    The mimetype is used for serialized objects, and tells the 
+    ResXResourceReader how to depersist the object. This is currently not 
+    extensible. For a given mimetype the value must be set accordingly:
+    
+    Note - application/x-microsoft.net.object.binary.base64 is the format 
+    that the ResXResourceWriter will generate, however the reader can 
+    read any of the formats listed below.
+    
+    mimetype: application/x-microsoft.net.object.binary.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
+            : and then encoded with base64 encoding.
+    
+    mimetype: application/x-microsoft.net.object.soap.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
+            : and then encoded with base64 encoding.
+
+    mimetype: application/x-microsoft.net.object.bytearray.base64
+    value   : The object must be serialized into a byte array 
+            : using a System.ComponentModel.TypeConverter
+            : and then encoded with base64 encoding.
+    -->
+  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
+    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
+    <xsd:element name="root" msdata:IsDataSet="true">
+      <xsd:complexType>
+        <xsd:choice maxOccurs="unbounded">
+          <xsd:element name="metadata">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" />
+              </xsd:sequence>
+              <xsd:attribute name="name" use="required" type="xsd:string" />
+              <xsd:attribute name="type" type="xsd:string" />
+              <xsd:attribute name="mimetype" type="xsd:string" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="assembly">
+            <xsd:complexType>
+              <xsd:attribute name="alias" type="xsd:string" />
+              <xsd:attribute name="name" type="xsd:string" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="data">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
+              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
+              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="resheader">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" />
+            </xsd:complexType>
+          </xsd:element>
+        </xsd:choice>
+      </xsd:complexType>
+    </xsd:element>
+  </xsd:schema>
+  <resheader name="resmimetype">
+    <value>text/microsoft-resx</value>
+  </resheader>
+  <resheader name="version">
+    <value>2.0</value>
+  </resheader>
+  <resheader name="reader">
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <resheader name="writer">
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+</root>