Index: /branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/HeuristicLab.Persistence.GUI.csproj
===================================================================
--- /branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/HeuristicLab.Persistence.GUI.csproj	(revision 1424)
+++ /branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/HeuristicLab.Persistence.GUI.csproj	(revision 1425)
@@ -42,7 +42,7 @@
   -->
   <ItemGroup>
-    <ProjectReference Include="..\Persistence\HeuristicLab.Persistence.csproj">
+    <ProjectReference Include="..\Persistence\HeuristicLab.Persistence-3.3.csproj">
       <Project>{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}</Project>
-      <Name>HeuristicLab.Persistence</Name>
+      <Name>HeuristicLab.Persistence-3.3</Name>
     </ProjectReference>
   </ItemGroup>
Index: /branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/PersistenceConfigurationForm.cs
===================================================================
--- /branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/PersistenceConfigurationForm.cs	(revision 1424)
+++ /branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/PersistenceConfigurationForm.cs	(revision 1425)
@@ -37,5 +37,5 @@
           } else {
             foreach (var pair in formatterTable) {
-              if (pair.Value.GetType().FullName == formatter.GetType().FullName) {
+              if (pair.Value.GetType().VersionInvariantName() == formatter.GetType().VersionInvariantName()) {
                 row.Cells["Formatter"].Value = pair.Key;
                 row.Cells["Active"].Value = true;
@@ -52,5 +52,5 @@
       var availableDecomposers = new Dictionary<string, IDecomposer>();
       foreach (IDecomposer d in ConfigurationService.Instance.Decomposers) {        
-        availableDecomposers.Add(d.GetType().FullName, d);
+        availableDecomposers.Add(d.GetType().VersionInvariantName(), d);
       }      
       foreach (IDecomposer decomposer in config.Decomposers) {       
@@ -58,5 +58,5 @@
         item.Checked = true;
         item.Tag = decomposer;
-        availableDecomposers.Remove(decomposer.GetType().FullName);
+        availableDecomposers.Remove(decomposer.GetType().VersionInvariantName());
       }      
       foreach (KeyValuePair<string, IDecomposer> pair in availableDecomposers) {
@@ -211,7 +211,7 @@
           formatterTable.Remove(formatterName);
           reverseFormatterTable.Remove(otherFormatter);
-          formatterTable.Add(otherFormatter.GetType().FullName, otherFormatter);
-          reverseFormatterTable.Add(otherFormatter, otherFormatter.GetType().FullName);
-          formatterName = formatter.GetType().FullName;
+          formatterTable.Add(otherFormatter.GetType().VersionInvariantName(), otherFormatter);
+          reverseFormatterTable.Add(otherFormatter, otherFormatter.GetType().VersionInvariantName());
+          formatterName = formatter.GetType().VersionInvariantName();
         }
         formatterTable.Add(formatterName, formatter);
@@ -226,7 +226,7 @@
             typeNameTable.Remove(typeName);
             reverseTypeNameTable.Remove(otherType);
-            typeNameTable.Add(otherType.FullName, otherType);
-            reverseTypeNameTable.Add(otherType, otherType.FullName);
-            typeName = formatter.Type.FullName;
+            typeNameTable.Add(otherType.VersionInvariantName(), otherType);
+            reverseTypeNameTable.Add(otherType, otherType.VersionInvariantName());
+            typeName = formatter.Type.VersionInvariantName();
             typeNameTable.Add(typeName, formatter.Type);
             reverseTypeNameTable.Add(formatter.Type, typeName);
@@ -249,5 +249,5 @@
 
     private void decomposerList_DragEnter(object sender, DragEventArgs e) {      
-      if ( e.Data.GetDataPresent(typeof(ListView.SelectedListViewItemCollection).FullName)) {
+      if ( e.Data.GetDataPresent(typeof(ListView.SelectedListViewItemCollection).VersionInvariantName())) {
         e.Effect = DragDropEffects.Move;
       } 
Index: /branches/New Persistence Exploration/Persistence/Persistence.sln
===================================================================
--- /branches/New Persistence Exploration/Persistence/Persistence.sln	(revision 1424)
+++ /branches/New Persistence Exploration/Persistence/Persistence.sln	(revision 1425)
@@ -2,5 +2,5 @@
 Microsoft Visual Studio Solution File, Format Version 10.00
 # Visual Studio 2008
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Persistence", "Persistence\HeuristicLab.Persistence.csproj", "{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}"
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Persistence-3.3", "Persistence\HeuristicLab.Persistence-3.3.csproj", "{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Persistence.Test", "Test\HeuristicLab.Persistence.Test.csproj", "{E2245078-6F40-449E-A370-01A97A7C5E6A}"
Index: /branches/New Persistence Exploration/Persistence/Persistence/Core/ConfigurationService.cs
===================================================================
--- /branches/New Persistence Exploration/Persistence/Persistence/Core/ConfigurationService.cs	(revision 1424)
+++ /branches/New Persistence Exploration/Persistence/Persistence/Core/ConfigurationService.cs	(revision 1425)
@@ -97,5 +97,5 @@
             Formatters[formatter.Format].Add(formatter);
           } catch (MissingMethodException) {
-            Console.WriteLine("WARNING: Could not instantiate {0}", t.FullName);
+            Console.WriteLine("WARNING: Could not instantiate {0}", t.VersionInvariantName());
           }          
         }
@@ -104,5 +104,5 @@
             Decomposers.Add((IDecomposer) Activator.CreateInstance(t, true));
           } catch (MissingMethodException) {
-            Console.WriteLine("WARNING: Could not instantiate {0}", t.FullName);
+            Console.WriteLine("WARNING: Could not instantiate {0}", t.VersionInvariantName());
           }
         }
Index: /branches/New Persistence Exploration/Persistence/Persistence/Core/DeSerializer.cs
===================================================================
--- /branches/New Persistence Exploration/Persistence/Persistence/Core/DeSerializer.cs	(revision 1424)
+++ /branches/New Persistence Exploration/Persistence/Persistence/Core/DeSerializer.cs	(revision 1425)
@@ -89,5 +89,5 @@
         throw new ApplicationException(String.Format(
           "No suitable method for deserialization of type \"{0}\" found.",
-          type.FullName));
+          type.VersionInvariantName()));
       }
       if ( start.Id != null )
@@ -111,5 +111,5 @@
         throw new ApplicationException(String.Format(
           "No suitable method for deserialization of type \"{0}\" found.",
-          type.FullName));
+          type.VersionInvariantName()));
       }
     }
Index: /branches/New Persistence Exploration/Persistence/Persistence/Core/Serializer.cs
===================================================================
--- /branches/New Persistence Exploration/Persistence/Persistence/Core/Serializer.cs	(revision 1424)
+++ /branches/New Persistence Exploration/Persistence/Persistence/Core/Serializer.cs	(revision 1425)
@@ -38,11 +38,11 @@
           IFormatter f = configuration.GetFormatter(pair.Key);
           if (f != null) {
-            serializer = f.GetType().AssemblyQualifiedName;
+            serializer = f.GetType().VersionInvariantName();
           } else {
             IDecomposer d = configuration.GetDecomposer(pair.Key);
             if (d != null)
-              serializer = d.GetType().AssemblyQualifiedName;
+              serializer = d.GetType().VersionInvariantName();
           }
-          result.Add(new TypeMapping(pair.Value, pair.Key.AssemblyQualifiedName, serializer));
+          result.Add(new TypeMapping(pair.Value, pair.Key.VersionInvariantName(), serializer));
         }
         return result;                                     
@@ -96,5 +96,5 @@
           String.Format(
           "No suitable method for serializing values of type \"{0}\" found.",
-          value.GetType().FullName));      
+          value.GetType().VersionInvariantName()));      
     }
 
Index: /branches/New Persistence Exploration/Persistence/Persistence/Default/Decomposers/TypeDecomposer.cs
===================================================================
--- /branches/New Persistence Exploration/Persistence/Persistence/Default/Decomposers/TypeDecomposer.cs	(revision 1424)
+++ /branches/New Persistence Exploration/Persistence/Persistence/Default/Decomposers/TypeDecomposer.cs	(revision 1425)
@@ -10,10 +10,10 @@
     public bool CanDecompose(Type type) {
       return type == typeof (Type) ||
-             type.FullName == "System.RuntimeType";
+             type.VersionInvariantName() == "System.RuntimeType, mscorlib";
     }
 
     public IEnumerable<Tag> DeCompose(object obj) {
       Type t = (Type) obj;
-      yield return new Tag("AssemblyQualifiedName", t.AssemblyQualifiedName);
+      yield return new Tag("VersionInvariantName", t.VersionInvariantName());
     }
 
Index: /branches/New Persistence Exploration/Persistence/Persistence/HeuristicLab.Persistence-3.3.csproj
===================================================================
--- /branches/New Persistence Exploration/Persistence/Persistence/HeuristicLab.Persistence-3.3.csproj	(revision 1425)
+++ /branches/New Persistence Exploration/Persistence/Persistence/HeuristicLab.Persistence-3.3.csproj	(revision 1425)
@@ -0,0 +1,121 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="3.5" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProductVersion>9.0.30729</ProductVersion>
+    <SchemaVersion>2.0</SchemaVersion>
+    <ProjectGuid>{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.Persistence</RootNamespace>
+    <AssemblyName>HeuristicLab.Persistence-3.3</AssemblyName>
+    <TargetFrameworkVersion>v3.5</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+    <StartupObject>
+    </StartupObject>
+    <SignAssembly>true</SignAssembly>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>bin\Debug\</OutputPath>
+    <DefineConstants>TRACE;DEBUG</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>bin\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+  <ItemGroup>
+    <Reference Include="System" />
+    <Reference Include="System.configuration" />
+    <Reference Include="System.Core">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.Data" />
+    <Reference Include="System.Data.DataSetExtensions">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="Core\Configuration.cs" />
+    <Compile Include="Core\TypeStringBuilder.cs" />
+    <Compile Include="Default\Decomposers\EnumerableDecomposer.cs" />
+    <Compile Include="Default\Decomposers\ArrayDecomposer.cs" />
+    <Compile Include="Default\Decomposers\KeyValuePairDecomposer.cs" />
+    <Compile Include="Default\Decomposers\DictionaryDecomposer.cs" />
+    <Compile Include="Default\Decomposers\StorableDecomposer.cs" />
+    <Compile Include="Default\Decomposers\TypeDecomposer.cs" />
+    <Compile Include="Default\Xml\Compact\IntArray2XmlFormatters.cs" />
+    <Compile Include="Default\Xml\Compact\DoubleArray2XmlFormatters.cs" />
+    <Compile Include="Default\Xml\Compact\DoubleList2XmlFormatter.cs" />
+    <Compile Include="Default\Xml\Compact\NumberEnumeration2XmlFormatter.cs" />
+    <Compile Include="Default\Xml\Compact\NumberArray2XmlFormatters.cs" />
+    <Compile Include="Core\DataMemberAccessor.cs" />
+    <Compile Include="Default\Xml\Compact\IntList2XmlFormatter.cs" />
+    <Compile Include="Default\Xml\Primitive\Sting2XmlFormatter.cs" />
+    <Compile Include="Default\Xml\Primitive\Int2XmlFormatter.cs" />
+    <Compile Include="Default\Xml\Primitive\Double2XmlFormatter.cs" />
+    <Compile Include="Default\Xml\Primitive\Boolean2XmlFormatter.cs" />
+    <Compile Include="Default\Xml\Primitive\DateTime2XmlFormatter.cs" />
+    <Compile Include="Default\Xml\XmlFormat.cs" />
+    <Compile Include="HeuristicLabPersistencePlugin.cs" />
+    <Compile Include="Core\DeSerializer.cs" />
+    <Compile Include="Interfaces\IDecomposer.cs" />
+    <Compile Include="Interfaces\IFormatter.cs" />
+    <Compile Include="Core\ConfigurationService.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="Core\Serializer.cs" />
+    <Compile Include="Interfaces\Tokens.cs" />
+    <Compile Include="Properties\Settings.Designer.cs">
+      <AutoGen>True</AutoGen>
+      <DesignTimeSharedInput>True</DesignTimeSharedInput>
+      <DependentUpon>Settings.settings</DependentUpon>
+    </Compile>
+    <Compile Include="Util.cs" />
+    <Compile Include="Core\StorableAttribute.cs" />
+    <Compile Include="Default\Xml\XmlGenerator.cs" />
+    <Compile Include="Default\Xml\XmlParser.cs" />
+  </ItemGroup>
+  <PropertyGroup>
+    <PreBuildEvent>SubWCRev "$(ProjectDir)\" "$(ProjectDir)\Properties\AssemblyInfo.frame" "$(ProjectDir)\Properties\AssemblyInfo.cs"</PreBuildEvent>
+    <PostBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set Outdir=$(Outdir)
+
+REM call CopyAssemblies.cmd
+REM call UpdateLocalInstallation.cmd</PostBuildEvent>
+  </PropertyGroup>
+  <ItemGroup>
+    <None Include="app.config" />
+    <None Include="HeuristicLab.snk" />
+    <None Include="Properties\Settings.settings">
+      <Generator>SettingsSingleFileGenerator</Generator>
+      <LastGenOutput>Settings.Designer.cs</LastGenOutput>
+    </None>
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\..\..\..\trunk\sources\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj">
+      <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
+      <Name>HeuristicLab.PluginInfrastructure</Name>
+    </ProjectReference>
+  </ItemGroup>
+</Project>
Index: anches/New Persistence Exploration/Persistence/Persistence/HeuristicLab.Persistence.csproj
===================================================================
--- /branches/New Persistence Exploration/Persistence/Persistence/HeuristicLab.Persistence.csproj	(revision 1424)
+++ 	(revision )
@@ -1,121 +1,0 @@
-﻿<?xml version="1.0" encoding="utf-8"?>
-<Project ToolsVersion="3.5" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
-  <PropertyGroup>
-    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
-    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
-    <ProductVersion>9.0.30729</ProductVersion>
-    <SchemaVersion>2.0</SchemaVersion>
-    <ProjectGuid>{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}</ProjectGuid>
-    <OutputType>Library</OutputType>
-    <AppDesignerFolder>Properties</AppDesignerFolder>
-    <RootNamespace>HeuristicLab.Persistence</RootNamespace>
-    <AssemblyName>HeuristicLab.Persistence</AssemblyName>
-    <TargetFrameworkVersion>v3.5</TargetFrameworkVersion>
-    <FileAlignment>512</FileAlignment>
-    <StartupObject>
-    </StartupObject>
-    <SignAssembly>true</SignAssembly>
-    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
-  </PropertyGroup>
-  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
-    <DebugSymbols>true</DebugSymbols>
-    <DebugType>full</DebugType>
-    <Optimize>false</Optimize>
-    <OutputPath>bin\Debug\</OutputPath>
-    <DefineConstants>TRACE;DEBUG</DefineConstants>
-    <ErrorReport>prompt</ErrorReport>
-    <WarningLevel>4</WarningLevel>
-  </PropertyGroup>
-  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
-    <DebugType>pdbonly</DebugType>
-    <Optimize>true</Optimize>
-    <OutputPath>bin\Release\</OutputPath>
-    <DefineConstants>TRACE</DefineConstants>
-    <ErrorReport>prompt</ErrorReport>
-    <WarningLevel>4</WarningLevel>
-  </PropertyGroup>
-  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
-  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
-       Other similar extension points exist, see Microsoft.Common.targets.
-  <Target Name="BeforeBuild">
-  </Target>
-  <Target Name="AfterBuild">
-  </Target>
-  -->
-  <ItemGroup>
-    <Reference Include="System" />
-    <Reference Include="System.configuration" />
-    <Reference Include="System.Core">
-      <RequiredTargetFramework>3.5</RequiredTargetFramework>
-    </Reference>
-    <Reference Include="System.Data" />
-    <Reference Include="System.Data.DataSetExtensions">
-      <RequiredTargetFramework>3.5</RequiredTargetFramework>
-    </Reference>
-    <Reference Include="System.Xml" />
-  </ItemGroup>
-  <ItemGroup>
-    <Compile Include="Core\Configuration.cs" />
-    <Compile Include="Core\TypeStringBuilder.cs" />
-    <Compile Include="Default\Decomposers\EnumerableDecomposer.cs" />
-    <Compile Include="Default\Decomposers\ArrayDecomposer.cs" />
-    <Compile Include="Default\Decomposers\KeyValuePairDecomposer.cs" />
-    <Compile Include="Default\Decomposers\DictionaryDecomposer.cs" />
-    <Compile Include="Default\Decomposers\StorableDecomposer.cs" />
-    <Compile Include="Default\Decomposers\TypeDecomposer.cs" />
-    <Compile Include="Default\Xml\Compact\IntArray2XmlFormatters.cs" />
-    <Compile Include="Default\Xml\Compact\DoubleArray2XmlFormatters.cs" />
-    <Compile Include="Default\Xml\Compact\DoubleList2XmlFormatter.cs" />
-    <Compile Include="Default\Xml\Compact\NumberEnumeration2XmlFormatter.cs" />
-    <Compile Include="Default\Xml\Compact\NumberArray2XmlFormatters.cs" />
-    <Compile Include="Core\DataMemberAccessor.cs" />
-    <Compile Include="Default\Xml\Compact\IntList2XmlFormatter.cs" />
-    <Compile Include="Default\Xml\Primitive\Sting2XmlFormatter.cs" />
-    <Compile Include="Default\Xml\Primitive\Int2XmlFormatter.cs" />
-    <Compile Include="Default\Xml\Primitive\Double2XmlFormatter.cs" />
-    <Compile Include="Default\Xml\Primitive\Boolean2XmlFormatter.cs" />
-    <Compile Include="Default\Xml\Primitive\DateTime2XmlFormatter.cs" />
-    <Compile Include="Default\Xml\XmlFormat.cs" />
-    <Compile Include="HeuristicLabPersistencePlugin.cs" />
-    <Compile Include="Core\DeSerializer.cs" />
-    <Compile Include="Interfaces\IDecomposer.cs" />
-    <Compile Include="Interfaces\IFormatter.cs" />
-    <Compile Include="Core\ConfigurationService.cs" />
-    <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="Core\Serializer.cs" />
-    <Compile Include="Interfaces\Tokens.cs" />
-    <Compile Include="Properties\Settings.Designer.cs">
-      <AutoGen>True</AutoGen>
-      <DesignTimeSharedInput>True</DesignTimeSharedInput>
-      <DependentUpon>Settings.settings</DependentUpon>
-    </Compile>
-    <Compile Include="Util.cs" />
-    <Compile Include="Core\StorableAttribute.cs" />
-    <Compile Include="Default\Xml\XmlGenerator.cs" />
-    <Compile Include="Default\Xml\XmlParser.cs" />
-  </ItemGroup>
-  <PropertyGroup>
-    <PreBuildEvent>SubWCRev "$(ProjectDir)\" "$(ProjectDir)\Properties\AssemblyInfo.frame" "$(ProjectDir)\Properties\AssemblyInfo.cs"</PreBuildEvent>
-    <PostBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
-set ProjectDir=$(ProjectDir)
-set SolutionDir=$(SolutionDir)
-set Outdir=$(Outdir)
-
-REM call CopyAssemblies.cmd
-REM call UpdateLocalInstallation.cmd</PostBuildEvent>
-  </PropertyGroup>
-  <ItemGroup>
-    <None Include="app.config" />
-    <None Include="HeuristicLab.snk" />
-    <None Include="Properties\Settings.settings">
-      <Generator>SettingsSingleFileGenerator</Generator>
-      <LastGenOutput>Settings.Designer.cs</LastGenOutput>
-    </None>
-  </ItemGroup>
-  <ItemGroup>
-    <ProjectReference Include="..\..\..\..\trunk\sources\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj">
-      <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
-      <Name>HeuristicLab.PluginInfrastructure</Name>
-    </ProjectReference>
-  </ItemGroup>
-</Project>
Index: /branches/New Persistence Exploration/Persistence/Test/HeuristicLab.Persistence.Test.csproj
===================================================================
--- /branches/New Persistence Exploration/Persistence/Test/HeuristicLab.Persistence.Test.csproj	(revision 1424)
+++ /branches/New Persistence Exploration/Persistence/Test/HeuristicLab.Persistence.Test.csproj	(revision 1425)
@@ -41,7 +41,7 @@
   -->
   <ItemGroup>
-    <ProjectReference Include="..\Persistence\HeuristicLab.Persistence.csproj">
+    <ProjectReference Include="..\Persistence\HeuristicLab.Persistence-3.3.csproj">
       <Project>{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}</Project>
-      <Name>HeuristicLab.Persistence</Name>
+      <Name>HeuristicLab.Persistence-3.3</Name>
     </ProjectReference>
   </ItemGroup>